%============================================================
%  Deterministic Steady State Computation
%============================================================
function F = SS_M01(x,xpar);

%bet sig th rho alp TPLL TPLH TPHL TPHH TP zeta muL muH xib ns del Tr L nx n1 n0 sde nL eta0 eta1 etaL ...
%    v m N1 NE NL N0 PsiT Psi00 Psi10 PsiL0 Psi01 Psi11 PsiL1 di V R lam C  KE KL K0 K1 PH PF D EXN YN gam Iv W...
%    f0 f1 fE K P00 P01 P10 P11 PL0 PL1 PLL PE LE LL L0 L1 Lp...
%    YLL YL0 YL1 Y00 Y01 Y10 Y11 YE VE VL V0 V1 Edisadv XOP;

% bet    = xpar(1);
% sig    = xpar(2); 
% th     = xpar(3);
% rho    = xpar(4);
% alp    = xpar(5); 
% del    = xpar(6); 
% n1    = xpar(7); 
% Tr    = xpar(8); 
% L     = xpar(9); 
% NE    = xpar(10);
% NL    =  xpar(11);
% N0    = xpar(12);
% N1    = xpar(12);

load xpar;
bet=xpar(1);
sig=xpar(2);
th=xpar(3);
rho=xpar(4);
alp=xpar(5);
TPLL=xpar(6);
TPLH=xpar(7);
TPHL=xpar(8);
TPHH=xpar(9);
zeta=xpar(10);
muH=xpar(11);
ns=xpar(12);
del=xpar(13);
Tr=xpar(14);
L=xpar(15);
nx=xpar(16);
n1=xpar(17);
eta1=xpar(18);
v=xpar(19);
m=xpar(20);
N1=xpar(21);
NE=xpar(22);
NL=xpar(23);
N0=xpar(24);
Edisadv=xpar(25);
XOP=xpar(26);

NE  =  (1-ns)/ns;
NL  = ns*NE*ns*TPLL/(1-TPLL*ns);
N1 = nx;
N0 = 1-NL-N1-ns*NE; 
 
KE    = exp(x(1));
KL    = exp(x(2));
K0    = exp(x(3));
K1    = exp(x(4));

C     = exp(x(5)); 
gam   = exp(x(6));
lam   = exp(x(7));
PH    = exp(x(8));
PF    = exp(x(9));

etaL  = x(10);
eta0  = x(11);

f0    = exp(x(12));
f1    = exp(x(13));
fE    = exp(x(14));

VE    = exp(x(15));
VL    = exp(x(16));
V0    = exp(x(17));
V1    = exp(x(18));


muL = 0.9;
sde = 0.4;
muH = 1;

muL   = exp(x(19));
sde   = exp(x(20));



v = 1/(1+alp*(th-1));
m = v*(th-1);

eta1 = norminv(n1,0,sde);  %  marginal exit productivity 

PsiT = exp(m^2*sde^2/2);
Psi00 = PsiT*normcdf(eta0,m*sde^2,sde);
Psi10 = PsiT*normcdf(eta1,m*sde^2,sde);
PsiL0 = PsiT*normcdf(etaL,m*sde^2,sde);
Psi01 = PsiT*(1-normcdf(eta0,m*sde^2,sde));
Psi11 = PsiT*(1-normcdf(eta1,m*sde^2,sde));
PsiL1 = PsiT*(1-normcdf(etaL,m*sde^2,sde));

nL = normcdf(etaL,0,sde);
n0 = normcdf(eta0,0,sde);
n1 = normcdf(eta1,0,sde);

K = NE*KE+ns*NE*KL+NL*KL+N0*K0+N1*K1;
Iv  = ns*del*K;

D = C+Iv;
W = (1-gam)/gam*C/(1-L);

P00 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*K0^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*Psi00*ns*N0 )^(1/(1-th));
P01 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*K0^(1-v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^(v-1)*Psi01*ns*N0 )^(1/(1-th));
P10 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*K1^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*Psi10*ns*N1 )^(1/(1-th));
P11 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*K1^(1-v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^(v-1)*Psi11*ns*N1 )^(1/(1-th));
PL0 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*PsiL0*ns*NL*(1-TPLL) )^(1/(1-th));
PL1 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^(v-1)*PsiL1*ns*NL*(1-TPLL) )^(1/(1-th));
PLL = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muL^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*PsiT*ns*NL*TPLL )^(1/(1-th));
PE0 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*PsiL0*ns*ns*NE*(1-TPLL) )^(1/(1-th));
PE1 = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muH^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^(v-1)*PsiL1*ns*ns*NE*(1-TPLL) )^(1/(1-th));
PEL = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muL^(v*(th-1))*KL^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*PsiT*ns*ns*NE*TPLL )^(1/(1-th));
PE  = ( (th/(th-1)/(1-alp)*W)^(1-th*v)*muL^(v*(th-1))*KE^(1-v)*( lam^rho*PH^(th-rho)*D )^(v-1)*PsiT*ns*NE )^(1/(1-th));



LE = PsiT*muL^((th-1)*v)*KE^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*( lam^rho*PH^(th-rho)*D )^v;
LL = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*( TPLL*muL^(v*(th-1))*( lam^rho*PH^(th-rho)*D )^v*PsiT ...
    + (1-TPLL)*muH^(v*(th-1))*( ( lam^rho*PH^(th-rho)*D )^v*PsiL0 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1 ) );
L0 = K0^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muH^(v*(th-1))*( ( lam^rho*PH^(th-rho)*D )^v*Psi00 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi01 );
L1 = K1^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muH^(v*(th-1))*( ( lam^rho*PH^(th-rho)*D )^v*Psi10 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi11 );

Lp = ns*(NE*LE + (ns*NE+NL)*LL + N0*L0 + N1*L1);


YLL = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*PsiT*TPLL*NL*ns*muL^((th-1)*v);
YL0 = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*PsiL0*(1-TPLL)*NL*ns*muH^((th-1)*v);
YL1 = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1*(1-TPLL)*NL*ns*muH^((th-1)*v);
YEL = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*PsiT*TPLL*NE*ns*ns*muL^((th-1)*v);
YE0 = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*PsiL0*(1-TPLL)*NE*ns*ns*muH^((th-1)*v);
YE1 = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1*(1-TPLL)*NE*ns*ns*muH^((th-1)*v);
Y00 = K0^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*Psi00*N0*ns*muH^((th-1)*v);
Y01 = K0^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi01*N0*ns*muH^((th-1)*v);
Y10 = K1^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*Psi10*N1*ns*muH^((th-1)*v);
Y11 = K1^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi11*N1*ns*muH^((th-1)*v);
YE  = KE^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( lam^rho*PH^(th-rho)*D )^v*PsiT*NE*ns*muL^((th-1)*v);

%YL1X = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1*(1-TPLL)*NL*ns*muH^((th-1)*v);
%YE1X = KL^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1*(1-TPLL)*NE*ns*ns*muH^((th-1)*v);
%Y01X = K0^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( (1-lam)^rho*PF^(th-rho)*D )^v*Psi01*N0*ns*muH^((th-1)*v);
%Y11X = K1^(1-v)*(th/(th-1)/(1-alp)*W)^(1-th*v)*( (1-lam)^rho*PF^(th-rho)*D )^v*Psi11*N1*ns*muH^((th-1)*v);

EXN = (1-lam)^rho*PF^(1-rho)*D;
YN = YE+YLL+YL0+YL1+Y00+Y01+Y10+Y11+YEL+YE0+YE1;


F(1) = lam^rho*PH^(1-rho) + (1-lam)^rho*PF^(1-rho) - 1;

F(2) = bet*ns*alp/(1-alp)*W*L1 - K1*(1-(1-ns*del)*bet);

F(3) = bet*ns*alp/(1-alp)*W*L0 - K0*(1-(1-ns*del)*bet);

F(4) = bet*ns*alp/(1-alp)*W*LL - KL*(1-(1-ns*del)*bet);

F(5) = bet*ns*alp/(1-alp)*W*LE - KE*(1-(1-ns*del)*bet);

F(6) = -KE + (1-ns)*bet*KE + ns*bet*VE - W*fE;

F(7) = -W*f0 + (th/(th-1)/(1-alp)-1)*W*K0^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muH^((th-1)*v)...
        *(  ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v -  ( lam^rho*PH^(th-rho)*D )^v )*exp(eta0)^((th-1)*v) ...
        - (K1-K0) + (1-ns)*bet*(K1-K0) + ns*bet*(V1-V0);

F(8) = -W*f1 + (th/(th-1)/(1-alp)-1)*W*K1^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muH^((th-1)*v)...
        *(  ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v -  ( lam^rho*PH^(th-rho)*D )^v )*exp(eta1)^((th-1)*v) ...
        - (K1-K0) + (1-ns)*bet*(K1-K0) + ns*bet*(V1-V0);

F(9) = -W*f0 + (th/(th-1)/(1-alp)-1)*W*KL^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muH^((th-1)*v)...
        *(  ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v -  ( lam^rho*PH^(th-rho)*D )^v )*exp(etaL)^((th-1)*v) ...
        - (K1-K0) + (1-ns)*bet*(K1-K0) + ns*bet*(V1-V0);

F(10) = Lp + N0*(1-n0)*f0 + (ns*NE+NL)*(1-TPLL)*(1-nL)*f0 + N1*(1-n1)*f1 + NE*fE- L;

F(11) = ns*( N0*(1-n0)+N1*(1-n1)+(1-TPLL)*(ns*NE+NL)*(1-nL) ) - N1;


F(12) = ( P00^(1-th)+P01^(1-th)+P10^(1-th)+P11^(1-th)+PL0^(1-th)+PL1^(1-th)+PLL^(1-th)+PE0^(1-th)+PE1^(1-th)+PEL^(1-th)+PE^(1-th) )^(1/(1-th)) - PH;

F(13) = ( P01^(1-th)+P11^(1-th)+PL1^(1-th)+PE1^(1-th) )^(1/(1-th)) - PF;

F(14) = Tr - EXN/YN;

F(15) = (th/(th-1)/(1-alp)-1)*W*KL^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)...
        *( (1-TPLL)*( ( lam^rho*PH^(th-rho)*D )^v*PsiL0 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*PsiL1 )*muH^((th-1)*v) ...
          + TPLL*( lam^rho*PH^(th-rho)*D )^v*PsiT*muL^((th-1)*v) ) + (1-del)*KL ...
        +(1-TPLL)*( (1-ns)*bet*(nL*K0 + (1-nL)*K1) + ns*bet*(nL*V0+(1-nL)*V1)- nL*K0 - (1-nL)*K1 - (1-nL)*W*f0 )...
        +TPLL*( (1-ns)*bet*KL + ns*bet*VL - KL ) - VL;
    
F(16) = (th/(th-1)/(1-alp)-1)*W*K0^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)...
        *( ( lam^rho*PH^(th-rho)*D )^v*Psi00 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi01 )*muH^((th-1)*v) ...
        + (1-del)*K0 + (1-ns)*bet*(n0*K0 + (1-n0)*K1) + ns*bet*(n0*V0+(1-n0)*V1)- n0*K0 - (1-n0)*K1 - (1-n0)*W*f0 - V0 ;

F(17) = (th/(th-1)/(1-alp)-1)*W*K1^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)...
        *( ( lam^rho*PH^(th-rho)*D )^v*Psi10 + ( lam^rho*PH^(th-rho)*D + (1-lam)^rho*PF^(th-rho)*D )^v*Psi11 )*muH^((th-1)*v) ...
        +(1-del)*K1 + (1-ns)*bet*(n1*K0 + (1-n1)*K1) + ns*bet*(n1*V0+(1-n1)*V1)- n1*K0 - (1-n1)*K1 - (1-n1)*W*f1 - V1;
    
F(18) = (th/(th-1)/(1-alp)-1)*W*KE^(1-v)*(th/(th-1)/(1-alp)*W)^(-th*v)*muL^((th-1)*v)*( lam^rho*PH^(th-rho)*D )^v*PsiT + (1-del)*KE - KL+(1-ns)*bet*KL + bet*ns*VL - VE;

F(19) = YE/(YLL+YL0+YL1+Y00+Y01+Y10+Y11+YEL+YE0+YE1)*(1-ns*NE)/(ns*NE) - Edisadv;

F(20) = log( (YL1+Y01+Y11+YE1)/(YE+YLL+YL0+Y00+Y10+YEL+YE0)*((1-N1)/N1) ) - XOP;

F=F';

