clc;
close all;
%%-----------------------------------------------------------------------------------------------------------------------------------------------
var YRh,YRf,Ch,Cf,Ivh,Ivf,Lh,Lf,Dh,Df,
    KEh,KEf,KLh,KLf,K0h,K0f,K1h,K1f,Kh,Kf,
    LEh,LEf,LLh,LLf,L0h,L0f,L1h,L1f,Lph,Lpf,
    etaLh,etaLf,eta0h,eta0f,eta1h,eta1f,nLh,nLf,n0h,n0f,
    n1h,n1f,NEh,NEf,NNh,NNf,NLh,NLf,N0h,N0f,
    N1h,N1f,Nh,Nf,Wh,Wf,Ph,Pfs,Phs,Pf,
    VEh,VEf,VLh,VLf,V0h,V0f,V1h,V1f,YNh,YNf,
    UCh,UCf,ULh,ULf,nstoph,nstopf,nstarth,nstartf,zh,zf,
    q,NXY,EXN,IMN,EXR,IMR;

varexo ezh, ezf;

load xss;
load paras;
%%-----------------------------------------------------------------------------------------------------------------------------------------------
parameters bet,sig,th,rho,alp, gam,lam,TPLL,muL,muH,  ns,del,sde,v,m,   sdz,corrz,rhoz,fE,f0,  f1,PsiT;

bet    =paras(1);   
sig    =paras(2);      
th     =paras(3);     
rho    =paras(4);      
alp    =paras(5);       
gam    =paras(6);      
lam    =paras(7);      
TPLL   =paras(8);       
muL    =paras(9);      
muH    =paras(10);        
ns     =paras(11);     
del    =paras(12);      
sde    =paras(13);      
v      =paras(14);    
m      =paras(15);    
sdz    =paras(16);      
corrz  =paras(17);         
rhoz   =paras(18);       
fE     =paras(19);     
f0     =paras(20);     
f1     =paras(21);     
PsiT   =paras(22);     

%%-----------------------------------------------------------------------------------------------------------------------------------------------
model; 

% 1 Wh
Wh = ULh-UCh;
% 2 Wf
Wf = ULf-UCf;

% 3 VLh 
exp(VLh) = ( th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*KLh(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*zh)
            *( (1-TPLL)*exp(v*(th-1)*muH)*( PsiT*normcdf(etaLh,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
               + PsiT*(1-normcdf(etaLh,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v )
               + TPLL*exp(v*(th-1)*muL)*PsiT*( lam^rho*exp((th-rho)*Ph+Dh) )^v ) 
           + (1-del)*exp(KLh(-1)) + (1-TPLL)*( (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(nLh+K0h) + (1-exp(nLh))*exp(K1h)) 
                                            + ns*bet*exp(UCh(+1)-UCh)*(exp(nLh)*exp(V0h(+1))+(1-exp(nLh))*exp(V1h(+1))) 
                                            - exp(nLh+K0h) - (1-exp(nLh))*exp(K1h) - (1-exp(nLh))*exp(q+Wf-zf)*f0 )
                                   +TPLL*( (1-ns)*bet*exp(UCh(+1)-UCh)*exp(KLh) + ns*bet*exp(UCh(+1)-UCh)*exp(VLh(+1)) - exp(KLh) );
% 4 VLf 
exp(VLf) = ( th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*KLf(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*zf)
            *( (1-TPLL)*exp(v*(th-1)*muH)*( PsiT*normcdf(etaLf,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
               + PsiT*(1-normcdf(etaLf,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v )
               + TPLL*exp(v*(th-1)*muL)*PsiT*( lam^rho*exp((th-rho)*Pfs+Df) )^v ) 
           + (1-del)*exp(KLf(-1)) + (1-TPLL)*( (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(nLf+K0f) + (1-exp(nLf))*exp(K1f)) 
                                            + ns*bet*exp(UCf(+1)-UCf)*(exp(nLf)*exp(V0f(+1))+(1-exp(nLf))*exp(V1f(+1))) 
                                            - exp(nLf+K0f) - (1-exp(nLf))*exp(K1f) - (1-exp(nLf))*exp(-q+Wh-zh)*f0 )
                                   +TPLL*( (1-ns)*bet*exp(UCf(+1)-UCf)*exp(KLf) + ns*bet*exp(UCf(+1)-UCf)*exp(VLf(+1)) - exp(KLf) );

% 5 V0h 
exp(V0h) = ( th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*K0h(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*(zh+muH))
            *( PsiT*normcdf(eta0h,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
             + PsiT*(1-normcdf(eta0h,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v )
           + (1-del)*exp(K0h(-1)) + (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(n0h+K0h) + (1-exp(n0h))*exp(K1h)) 
           + ns*bet*exp(UCh(+1)-UCh)*(exp(n0h)*exp(V0h(+1))+(1-exp(n0h))*exp(V1h(+1)))- exp(n0h+K0h) - (1-exp(n0h))*exp(K1h) - (1-exp(n0h))*exp(q+Wf-zf)*f0;
% 6 V0f            
exp(V0f) = ( th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*K0f(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*(zf+muH))
            *( PsiT*normcdf(eta0f,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
             + PsiT*(1-normcdf(eta0f,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v )
           + (1-del)*exp(K0f(-1)) + (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(n0f+K0f) + (1-exp(n0f))*exp(K1f)) 
           + ns*bet*exp(UCf(+1)-UCf)*(exp(n0f)*exp(V0f(+1))+(1-exp(n0f))*exp(V1f(+1)))- exp(n0f+K0f) - (1-exp(n0f))*exp(K1f) - (1-exp(n0f))*exp(-q+Wh-zh)*f0;

% 7 V1h 
exp(V1h) = ( th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*K1h(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*(zh+muH))
            *( PsiT*normcdf(eta1h,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
             + PsiT*(1-normcdf(eta1h,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v )
           + (1-del)*exp(K1h(-1)) + (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(n1h+K0h) + (1-exp(n1h))*exp(K1h)) 
           + ns*bet*exp(UCh(+1)-UCh)*(exp(n1h)*exp(V0h(+1))+(1-exp(n1h))*exp(V1h(+1)))- exp(n1h+K0h) - (1-exp(n1h))*exp(K1h) - (1-exp(n1h))*exp(q+Wf-zf)*f1;
% 8 V1f            
exp(V1f) = ( th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*K1f(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*(zf+muH))
            *( PsiT*normcdf(eta1f,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
             + PsiT*(1-normcdf(eta1f,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v )
           + (1-del)*exp(K1f(-1)) + (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(n1f+K0f) + (1-exp(n1f))*exp(K1f)) 
           + ns*bet*exp(UCf(+1)-UCf)*(exp(n1f)*exp(V0f(+1))+(1-exp(n1f))*exp(V1f(+1)))- exp(n1f+K0f) - (1-exp(n1f))*exp(K1f) - (1-exp(n1f))*exp(-q+Wh-zh)*f1;

% 9 VEh
exp(VEh) = (th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*KEh(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*(zh+muL))*( lam^rho*exp((th-rho)*Ph+Dh) )^v*PsiT 
            + (1-del)*exp(KEh(-1)) - exp(KLh)+(1-ns)*bet*exp(UCh(+1)-UCh)*exp(KLh) + ns*bet*exp(UCh(+1)-UCh)*exp(VLh(+1));

% 10 VEf
exp(VEf) = (th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*KEf(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*(zf+muL))*( lam^rho*exp((th-rho)*Pfs+Df) )^v*PsiT 
            + (1-del)*exp(KEf(-1)) - exp(KLf)+(1-ns)*bet*exp(UCf(+1)-UCf)*exp(KLf) + ns*bet*exp(UCf(+1)-UCf)*exp(VLf(+1));

% 11 etaLh
exp(q+Wf-zf)*f0 = (th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*KLh(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*zh+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df ) )^v -  ( lam^rho*exp((th-rho)*Ph+Dh) )^v )*exp(v*(th-1)*etaLh)
            - (exp(K1h)-exp(K0h)) + (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(K1h)-exp(K0h)) + ns*bet*exp(UCh(+1)-UCh)*(exp(V1h(+1))-exp(V0h(+1)));
% 12 etaLf
exp(-q+Wh-zh)*f0 = (th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*KLf(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*zf+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v -  ( lam^rho*exp((th-rho)*Pfs+Df) )^v )*exp(v*(th-1)*etaLf)
            - (exp(K1f)-exp(K0f)) + (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(K1f)-exp(K0f)) + ns*bet*exp(UCf(+1)-UCf)*(exp(V1f(+1))-exp(V0f(+1)));

% 13 eta0h
exp(q+Wf-zf)*f0 = (th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*K0h(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*zh+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v -  ( lam^rho*exp((th-rho)*Ph+Dh) )^v )*exp(v*(th-1)*eta0h)
            - (exp(K1h)-exp(K0h)) + (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(K1h)-exp(K0h)) + ns*bet*exp(UCh(+1)-UCh)*(exp(V1h(+1))-exp(V0h(+1)));
% 14 eta0f
exp(-q+Wh-zh)*f0 = (th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*K0f(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*zf+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v -  ( lam^rho*exp((th-rho)*Pfs+Df) )^v )*exp(v*(th-1)*eta0f)
            - (exp(K1f)-exp(K0f)) + (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(K1f)-exp(K0f)) + ns*bet*exp(UCf(+1)-UCf)*(exp(V1f(+1))-exp(V0f(+1)));
% 15 eta1h
exp(q+Wf-zf)*f1 = (th/(th-1)/(1-alp)-1)*exp(Wh+(1-v)*K1h(-1))*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*exp(v*(th-1)*zh+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v -  ( lam^rho*exp((th-rho)*Ph+Dh) )^v )*exp(v*(th-1)*eta1h)
            - (exp(K1h)-exp(K0h)) + (1-ns)*bet*exp(UCh(+1)-UCh)*(exp(K1h)-exp(K0h)) + ns*bet*exp(UCh(+1)-UCh)*(exp(V1h(+1))-exp(V0h(+1)));
% 16 eta1f
exp(-q+Wh-zh)*f1 = (th/(th-1)/(1-alp)-1)*exp(Wf+(1-v)*K1f(-1))*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*exp(v*(th-1)*zf+v*(th-1)*muH)
            *(  ( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v -  ( lam^rho*exp((th-rho)*Pfs+Df) )^v )*exp(v*(th-1)*eta1f)
            - (exp(K1f)-exp(K0f)) + (1-ns)*bet*exp(UCf(+1)-UCf)*(exp(K1f)-exp(K0f)) + ns*bet*exp(UCf(+1)-UCf)*(exp(V1f(+1))-exp(V0f(+1)));
    
% 17 KEh
1 = bet*exp(UCh(+1)-UCh)*( alp/(1-alp)*ns*exp(Wh(+1)+LEh(+1)-KEh) + (1-ns*del) );
% 18 KEf
1 = bet*exp(UCf(+1)-UCf)*( alp/(1-alp)*ns*exp(Wf(+1)+LEf(+1)-KEf) + (1-ns*del) );

% 19 KLh
1 = bet*exp(UCh(+1)-UCh)*( alp/(1-alp)*ns*exp(Wh(+1)+LLh(+1)-KLh) + (1-ns*del) );
% 20 KLf
1 = bet*exp(UCf(+1)-UCf)*( alp/(1-alp)*ns*exp(Wf(+1)+LLf(+1)-KLf) + (1-ns*del) );

% 21 K0h
1 = bet*exp(UCh(+1)-UCh)*( alp/(1-alp)*ns*exp(Wh(+1)+L0h(+1)-K0h) + (1-ns*del) );
% 22 K0f
1 = bet*exp(UCf(+1)-UCf)*( alp/(1-alp)*ns*exp(Wf(+1)+L0f(+1)-K0f) + (1-ns*del) );

% 23 K1h
1 = bet*exp(UCh(+1)-UCh)*( alp/(1-alp)*ns*exp(Wh(+1)+L1h(+1)-K1h) + (1-ns*del) );
% 24 K1f
1 = bet*exp(UCf(+1)-UCf)*( alp/(1-alp)*ns*exp(Wf(+1)+L1f(+1)-K1f) + (1-ns*del) );

% 25 nLh 
exp(nLh) = normcdf(etaLh,0,sde);
% 26 nLf 
exp(nLf) = normcdf(etaLf,0,sde);
% 27 n0h 
exp(n0h) = normcdf(eta0h,0,sde);
% 28 n0f 
exp(n0f) = normcdf(eta0f,0,sde);
% 29 n1h 
exp(n1h) = normcdf(eta1h,0,sde);
% 30 n1f 
exp(n1f) = normcdf(eta1f,0,sde);

%31 ULh
exp(ULh) = (1-gam)*exp(((1-sig)*gam)*Ch)*(1-exp(Lh))^((1-sig)*(1-gam)-1);
%32 ULf
exp(ULf) = (1-gam)*exp(((1-sig)*gam)*Cf)*(1-exp(Lf))^((1-sig)*(1-gam)-1);

%33 NNh
exp(NNh) = ns*exp(NEh(-1));
%34 NNf
exp(NNf) = ns*exp(NEf(-1));
%35 NLh
exp(NLh) = ns*TPLL*( exp(NNh(-1)) + exp(NLh(-1)) );
%36 NLf
exp(NLf) = ns*TPLL*( exp(NNf(-1)) + exp(NLf(-1)) );
%37 N0h
exp(N0h) = ns*(1-TPLL)*( exp(NNh(-1)) + exp(NLh(-1)) )*exp(nLh) + ns*exp(N0h(-1))*exp(n0h) + ns*exp(N1h(-1))*exp(n1h);
%38 N0f
exp(N0f) = ns*(1-TPLL)*( exp(NNf(-1)) + exp(NLf(-1)) )*exp(nLf) + ns*exp(N0f(-1))*exp(n0f) + ns*exp(N1f(-1))*exp(n1f);
%39 N1h
exp(N1h) = ns*(1-TPLL)*( exp(NNh(-1)) + exp(NLh(-1)) )*(1-exp(nLh)) + ns*exp(N0h(-1))*(1-exp(n0h)) + ns*exp(N1h(-1))*(1-exp(n1h));
%40 N1f
exp(N1f) = ns*(1-TPLL)*( exp(NNf(-1)) + exp(NLf(-1)) )*(1-exp(nLf)) + ns*exp(N0f(-1))*(1-exp(n0f)) + ns*exp(N1f(-1))*(1-exp(n1f));
%41 Nh
exp(Nh) = exp(NNh)+exp(NLh)+exp(N0h)+exp(N1h);
%42 Nf
exp(Nf) = exp(NNf)+exp(NLf)+exp(N0f)+exp(N1f);

%43 LEh
exp(LEh) = PsiT*exp( v*(th-1)*zh+v*(th-1)*muL + (1-v)*KEh(-1) )*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)*( lam^rho*exp((th-rho)*Ph+Dh) )^v;
%44 LEf
exp(LEf) = PsiT*exp( v*(th-1)*zf+v*(th-1)*muL + (1-v)*KEf(-1) )*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)*( lam^rho*exp((th-rho)*Pfs+Df) )^v;
%45 LLh
exp(LLh) = exp( v*(th-1)*zh + (1-v)*KLh(-1) )*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)
            *( TPLL*exp(v*(th-1)*muL)*( lam^rho*exp((th-rho)*Ph+Dh) )^v*PsiT
             + (1-TPLL)*exp(v*(th-1)*muH)*( PsiT*normcdf(etaLh,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
               + PsiT*(1-normcdf(etaLh,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v ) );
%46 LLf
exp(LLf) = exp( v*(th-1)*zf + (1-v)*KLf(-1) )*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)
            *( TPLL*exp(v*(th-1)*muL)*( lam^rho*exp((th-rho)*Pfs+Df) )^v*PsiT
             + (1-TPLL)*exp(v*(th-1)*muH)*( PsiT*normcdf(etaLf,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
               + PsiT*(1-normcdf(etaLf,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v ) );
%47 L0h
exp(L0h) = exp( v*(th-1)*zh + (1-v)*K0h(-1) )*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)* exp(v*(th-1)*muH)
            *( PsiT*normcdf(eta0h,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
               + PsiT*(1-normcdf(eta0h,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v );
%48 L0f
exp(L0f) = exp( v*(th-1)*zf + (1-v)*K0f(-1) )*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)* exp(v*(th-1)*muH)
            *( PsiT*normcdf(eta0f,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
               + PsiT*(1-normcdf(eta0f,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v );
%49 L1h
exp(L1h) = exp( v*(th-1)*zh + (1-v)*K1h(-1) )*(th/(th-1)/(1-alp)*exp(Wh))^(-th*v)* exp(v*(th-1)*muH)
            *( PsiT*normcdf(eta1h,m*sde^2,sde)*( lam^rho*exp((th-rho)*Ph+Dh) )^v 
               + PsiT*(1-normcdf(eta1h,m*sde^2,sde))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^v );
%50 L1f
exp(L1f) = exp( v*(th-1)*zf + (1-v)*K1f(-1) )*(th/(th-1)/(1-alp)*exp(Wf))^(-th*v)* exp(v*(th-1)*muH)
            *( PsiT*normcdf(eta1f,m*sde^2,sde)*( lam^rho*exp((th-rho)*Pfs+Df) )^v 
               + PsiT*(1-normcdf(eta1f,m*sde^2,sde))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^v );
%51 Lph
exp(Lph) = ns*exp(NEh(-1)+LEh)+ns*(exp(NNh(-1))+exp(NLh(-1)))*exp(LLh) + ns*exp(N0h(-1)+L0h) + ns*exp(N1h(-1)+L1h);
%52 Lpf
exp(Lpf) = ns*exp(NEf(-1)+LEf)+ns*(exp(NNf(-1))+exp(NLf(-1)))*exp(LLf) + ns*exp(N0f(-1)+L0f) + ns*exp(N1f(-1)+L1f);

%53 Ph
exp((1-th)*Ph)=
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K0h(-1))*( lam^rho*exp((th-rho)*Ph+Dh) )^(v-1)*ns*exp(N0h(-1))*PsiT*normcdf(eta0h,m*sde^2,sde) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K0h(-1))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*exp(N0h(-1))*PsiT*(1-normcdf(eta0h,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K1h(-1))*( lam^rho*exp((th-rho)*Ph+Dh) )^(v-1)*ns*exp(N1h(-1))*PsiT*normcdf(eta1h,m*sde^2,sde) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K1h(-1))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*exp(N1h(-1))*PsiT*(1-normcdf(eta1h,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*KLh(-1))*( lam^rho*exp((th-rho)*Ph+Dh) )^(v-1)*ns*(exp(NLh(-1))+exp(NNh(-1)))*PsiT*normcdf(etaLh,m*sde^2,sde)*(1-TPLL) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*KLh(-1))*( lam^rho*exp((th-rho)*Ph+Dh) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*(exp(NLh(-1))+exp(NNh(-1)))*PsiT*(1-normcdf(etaLh,m*sde^2,sde))*(1-TPLL) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muL)*exp((1-v)*KLh(-1))*( lam^rho*exp((th-rho)*Ph+Dh) )^(v-1)*ns*(exp(NLh(-1))+exp(NNh(-1)))*PsiT*TPLL +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muL)*exp((1-v)*KEh(-1))*( lam^rho*exp((th-rho)*Ph+Dh) )^(v-1)*ns*(exp(NEh(-1)))*PsiT;
%54 Pfs
exp((1-th)*Pfs)=
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K0f(-1))*( lam^rho*exp((th-rho)*Pfs+Df) )^(v-1)*ns*exp(N0f(-1))*PsiT*normcdf(eta0f,m*sde^2,sde) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K0f(-1))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*exp(N0f(-1))*PsiT*(1-normcdf(eta0f,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K1f(-1))*( lam^rho*exp((th-rho)*Pfs+Df) )^(v-1)*ns*exp(N1f(-1))*PsiT*normcdf(eta1f,m*sde^2,sde) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K1f(-1))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*exp(N1f(-1))*PsiT*(1-normcdf(eta1f,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*KLf(-1))*( lam^rho*exp((th-rho)*Pfs+Df) )^(v-1)*ns*(exp(NLf(-1))+exp(NNf(-1)))*PsiT*normcdf(etaLf,m*sde^2,sde)*(1-TPLL) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*KLf(-1))*( lam^rho*exp((th-rho)*Pfs+Df) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*(exp(NLf(-1))+exp(NNf(-1)))*PsiT*(1-normcdf(etaLf,m*sde^2,sde))*(1-TPLL) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muL)*exp((1-v)*KLf(-1))*( lam^rho*exp((th-rho)*Pfs+Df) )^(v-1)*ns*(exp(NLf(-1))+exp(NNf(-1)))*PsiT*TPLL +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muL)*exp((1-v)*KEf(-1))*( lam^rho*exp((th-rho)*Pfs+Df) )^(v-1)*ns*(exp(NEf(-1)))*PsiT;

%55 Phs
exp((1-th)*(Phs+q))=
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K0h(-1))*( lam^rho*exp((th-rho)*Ph+Dh ) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*exp(N0h(-1))*PsiT*(1-normcdf(eta0h,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*K1h(-1))*( lam^rho*exp((th-rho)*Ph+Dh ) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*exp(N1h(-1))*PsiT*(1-normcdf(eta1h,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wh))^(1-th*v)*exp(v*(th-1)*zh)*exp(v*(th-1)*muH)*exp((1-v)*KLh(-1))*( lam^rho*exp((th-rho)*Ph+Dh ) + (1-lam)^rho*exp(th*q+(th-rho)*Phs+Df) )^(v-1)*ns*(exp(NLh(-1))+exp(NNh(-1)))*PsiT*(1-normcdf(etaLh,m*sde^2,sde))*(1-TPLL);

%56 Pf
exp((1-th)*(Pf-q))=
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K0f(-1))*( lam^rho*exp((th-rho)*Pfs+Df ) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*exp(N0f(-1))*PsiT*(1-normcdf(eta0f,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*K1f(-1))*( lam^rho*exp((th-rho)*Pfs+Df ) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*exp(N1f(-1))*PsiT*(1-normcdf(eta1f,m*sde^2,sde)) +
(th/(th-1)/(1-alp)*exp(Wf))^(1-th*v)*exp(v*(th-1)*zf)*exp(v*(th-1)*muH)*exp((1-v)*KLf(-1))*( lam^rho*exp((th-rho)*Pfs+Df ) + (1-lam)^rho*exp(-th*q+(th-rho)*Pf+Dh) )^(v-1)*ns*(exp(NLf(-1))+exp(NNf(-1)))*PsiT*(1-normcdf(etaLf,m*sde^2,sde))*(1-TPLL);

% 57 Ch 
1 = lam^rho*exp((1-rho)*Ph) + (1-lam)^rho*exp((1-rho)*Pf);
% 58 Cf
1 = lam^rho*exp((1-rho)*Pfs) + (1-lam)^rho*exp((1-rho)*Phs);

% 59 UCh
exp(UCh) = gam*exp(((1-sig)*gam-1)*Ch)*(1-exp(Lh))^((1-sig)*(1-gam));
% 60 UCf
exp(UCf) = gam*exp(((1-sig)*gam-1)*Cf)*(1-exp(Lf))^((1-sig)*(1-gam));

% 61 YNh
exp(YNh) = th/(th-1)/(1-alp)*exp(Wh+Lph);
% 62 YNf
exp(YNf) = th/(th-1)/(1-alp)*exp(Wf+Lpf);

%63 YRh
exp(YRh) = exp(YNh-Ph);
%64 YRf
exp(YRf) = exp(YNf-Pfs);

% 65 Dh
exp(Dh) = exp(Ch)+exp(Ivh);
% 66 Df
exp(Df) = exp(Cf)+exp(Ivf);

% 67 Ivh 
exp(Ivh) = exp(Kh) - (1-del*ns)*exp(Kh(-1));
% 68 Ivf 
exp(Ivf) = exp(Kf) - (1-del*ns)*exp(Kf(-1));

% 69 EXN
EXN = rho*log(1-lam)+(1-rho)*Phs+Df+q;
% 70 IMN
IMN = rho*log(1-lam)+(1-rho)*Pf+Dh;

% 71 NXY
NXY = (exp(EXN)-exp(IMN))/exp(YNh);
%72 q
q = UCf-UCh;

%73 EXR
EXR = EXN-(Phs+q);
%74 IMR
IMR = IMN-Pf;

% 75 Zh
zh = rhoz*zh(-1) + sdz*ezh;
% 76 Zf
zf = rhoz*zf(-1) + sdz*ezf;

% 77 nstarth
exp(nstarth) = ( ns*(1-TPLL)*( exp(NNh(-1)) + exp(NLh(-1)) )*(1-exp(nLh)) + ns*exp(N0h(-1))*(1-exp(n0h)) )/(ns*( exp(NNh(-1)) + exp(NLh(-1))+ exp(N0h(-1)) ) );
% 78 nstartf
exp(nstartf) = ( ns*(1-TPLL)*( exp(NNf(-1)) + exp(NLf(-1)) )*(1-exp(nLf)) + ns*exp(N0f(-1))*(1-exp(n0f)) )/(ns*( exp(NNf(-1)) + exp(NLf(-1))+ exp(N0f(-1)) ) );

% 79 nstoph
nstoph = n1h;
% 80 nstopf
nstopf = n1f;

%81 Kh
exp(Kh) = exp(KEh+NEh)+exp(KLh+NNh)+exp(KLh+NLh)+exp(K0h+N0h)+exp(K1h+N1h);
%82 Kf
exp(Kf) = exp(KEf+NEf)+exp(KLf+NNf)+exp(KLf+NLf)+exp(K0f+N0f)+exp(K1f+N1f);

%83 NEh
exp(Wh-zh)*fE = -exp(KEh) + ns*bet*exp(UCh(+1)-UCh+VEh(+1)) + (1-ns)*bet*exp(UCh(+1)-UCh+KEh);
%84 NEf
exp(Wf-zf)*fE = -exp(KEf) + ns*bet*exp(UCf(+1)-UCf+VEf(+1)) + (1-ns)*bet*exp(UCf(+1)-UCf+KEf);

%85 Lh
exp(Lh) = exp(Lph) + exp(-zf)*f0*ns*(1-TPLL)*( exp(NNf(-1)) + exp(NLf(-1)) )*(1-exp(nLf)) 
          + exp(-zf)*f0*ns*exp(N0f(-1))*(1-exp(n0f)) + exp(-zf)*f1*ns*exp(N1f(-1))*(1-exp(n1f))
          + exp(-zh)*fE*exp(NEh);
%86 Lf
exp(Lf) = exp(Lpf) + exp(-zh)*f0*ns*(1-TPLL)*( exp(NNh(-1)) + exp(NLh(-1)) )*(1-exp(nLh)) 
          + exp(-zh)*f0*ns*exp(N0h(-1))*(1-exp(n0h)) + exp(-zh)*f1*ns*exp(N1h(-1))*(1-exp(n1h))
          + exp(-zf)*fE*exp(NEf);


end;
%---------------------------------------------
%  -------------  END OF MODEL   -------------
%---------------------------------------------

initval;

YRh        =xss(1);
YRf        =xss(2);
Ch         =xss(3);
Cf         =xss(4);
Ivh        =xss(5);
Ivf        =xss(6);
Lh         =xss(7);
Lf         =xss(8);
Dh         =xss(9);
Df         =xss(10);
KEh        =xss(11);
KEf        =xss(12);
KLh        =xss(13);
KLf        =xss(14);
K0h        =xss(15);
K0f        =xss(16);
K1h        =xss(17);
K1f        =xss(18);
Kh         =xss(19);
Kf         =xss(20);
LEh        =xss(21);
LEf        =xss(22);
LLh        =xss(23);
LLf        =xss(24);
L0h        =xss(25);
L0f        =xss(26);
L1h        =xss(27);
L1f        =xss(28);
Lph        =xss(29);
Lpf        =xss(30);
etaLh      =xss(31);
etaLf      =xss(32);
eta0h      =xss(33);
eta0f      =xss(34);
eta1h      =xss(35);
eta1f      =xss(36);
nLh        =xss(37);
nLf        =xss(38);
n0h        =xss(39);
n0f        =xss(40);
n1h        =xss(41);
n1f        =xss(42);
NEh        =xss(43);
NEf        =xss(44);
NNh        =xss(45);
NNf        =xss(46);
NLh        =xss(47);
NLf        =xss(48);
N0h        =xss(49);
N0f        =xss(50);
N1h        =xss(51);
N1f        =xss(52);
Nh         =xss(53);
Nf         =xss(54);
Wh         =xss(55);
Wf         =xss(56);
Ph         =xss(57);
Pfs        =xss(58);
Phs        =xss(59);
Pf         =xss(60);
VEh        =xss(61);
VEf        =xss(62);
VLh        =xss(63);
VLf        =xss(64);
V0h        =xss(65);
V0f        =xss(66);
V1h        =xss(67);
V1f        =xss(68);
YNh        =xss(69);
YNf        =xss(70);
UCh        =xss(71);
UCf        =xss(72);
ULh        =xss(73);
ULf        =xss(74);
nstoph     =xss(75);
nstopf     =xss(76);
nstarth    =xss(77);
nstartf    =xss(78);
zh         =xss(79);
zf         =xss(80);
q          =xss(81);
NXY        =xss(82);
EXN        =xss(83);
IMN        =xss(84);
EXR        =xss(85);
IMR        =xss(86);

end;


%-----------------------
%----    SHOCKS   ------
%-----------------------
shocks;

var ezh = 1;  % aggregate productivity 
var ezf = 1;
var ezh,ezf = corrz*sdz^2;

end;

%-----------------------
%----    SOLVE THE MODEL   ------
%-----------------------
steady;
check;
resid(1);

%stoch_simul(order=1, nograph);
stoch_simul(order=1,hp_filter=6.25,irf=100, nograph);
